#!/usr/bin/env python

# makeboxref.py <threed file> [sym=<sym>] [ang=<dalt>] [phi=<dphi>] [nref=<n to gen>]

import os
import sys
import string
from sys import argv
from os import system

if (len(argv)<2):
	print "makeboxref.py <threed file> [sym=<sym>] [ang=<dalt>] [phi=<dphi>] [nref=<n to gen>]"
	sys.exit(1)

sym="c1"
ang=-1
phi=22.5
nref=40

for i in argv[2:] :
	s=string.split(i,'=')
	if (s[0]=="sym") : sym=s[1]
	elif (s[0]=="ang") : ang=float(s[1])
	elif (s[0]=="phi") : phi=float(s[1])
	elif (s[0]=="nref") : nref=int(s[1])
	else: error(ERR_EXIT,"Unknown argument "+i)

if (ang==-1):
	ang=22.5
	div=1
	if (sym[0]=="c" or sym[0]=="C"): div=float(sym[1:])/4
	if (sym[0]=="d" or sym[0]=='D'): div=float(sym[1:])/2
	if (div<1.0) : div=1.0
	ang=ang/div
	print "angular spacing set to %f"%ang

system("project3d %s out=allphi.hed sym=%s prop=%f phitoo=%f"%(argv[1],sym,ang,phi))

system("classesbymra allphi.hed allphi.hed norot matrix split")

system("rm cls*.lst")

system("mx2img matrix.dat matrix.mrc")

system("matrixembed matrix.mrc self.loc euler=allphi.hed bestref=%d"%nref)

print "\n\nProcessing complete. Best refs are in 'best.hed'."

